#include <iostream>
using namespace std;

int main()
{
    int A, B, C, D, E, n, An, Bn, Cn, Dn, En, max_num, brmax;
    n = 0;
    brmax = 1;
    cin>>A;
    cin>>B;
    cin>>C;
    cin>>D;
    cin>>E;

    max_num = D;

    if(C == D)
    {
        brmax++;
    }

    if(C == B)
    {
        brmax++;
    }

    if(B == A)
    {
        brmax++;
    }

    An = A*A*A;
    Bn = B*B*B;
    Cn = C*C*C;
    Dn = D*D*D;
    En = E*E*E;

    if(An + Bn + Cn + Dn <= En)
    {
        if(brmax >= 2)
        {
            if(2 * max_num > E)
            {
                if(max_num + A <= E && max_num + B <= E)
                {
                    n = brmax;
                }
                else
                {
                    if(max_num + A <= E)
                    {
                        if(max_num + B > E)
                        {
                            n = brmax + 1;
                        }
                    }
                    else
                    {
                        n = brmax + 2;
                    }
                }
            }
            else
            {
                n = 1;
            }
        }
        else
        {
            if(max_num < E)
            {
                if(max_num + A <= E && max_num + B <= E && max_num + C <= E)
                {
                    n = 1;
                }
                else
                {
                    if(max_num + A <= E)
                    {
                        if(max_num + B <= E)
                        {
                            if(max_num + C > E)
                            {
                                n = 2;
                            }
                        }
                        else
                        {
                            if(B + C <= E)
                            {
                                n = 2;
                            }
                            else
                            {
                                if(A + B <= E)
                                {
                                    n = 3;
                                }
                                else
                                {
                                    n = 4;
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if(B + C <= E)
                {
                    n = 2;
                }
                else
                {
                    if(A + B <= E)
                    {
                        n = 3;
                    }
                    else
                    {
                        n = 4;
                    }
                }
            }
        }
    }
    else
    {
        if(brmax >= 2)
        {
            if(2 * max_num > E)
            {
                if(max_num + A <= E && max_num + B <= E)
                {
                    n = brmax;
                }
                else
                {
                    if(max_num + A <= E)
                    {
                        if(max_num + B > E)
                        {
                            n = brmax + 1;
                        }
                    }
                    else
                    {
                        n = brmax + 2;
                    }
                }
            }
            else
            {
                n = 1;
            }
        }
        else
        {
            if(max_num < E)
            {
                if(max_num + A <= E && max_num + B <= E && max_num + C <= E)
                {
                    n = 1;
                }
                else
                {
                    if(max_num + A <= E)
                    {
                        if(max_num + B <= E)
                        {
                            if(max_num + C > E)
                            {
                                n = 2;
                            }
                        }
                        else
                        {
                            if(B + C <= E)
                            {
                                n = 2;
                            }
                            else
                            {
                                if(A + B <= E)
                                {
                                    n = 3;
                                }
                                else
                                {
                                    n = 4;
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                if(B + C <= E)
                {
                    n = 2;
                }
                else
                {
                    if(A + B <= E)
                    {
                        n = 3;
                    }
                    else
                    {
                        n = 4;
                    }
                }
            }
        }
    }

    cout<<n;

    return 0;
}
